<template>
  <v-row class="pt-2">
    <v-col>
      <v-card outlined class="panel">
        <v-card-title>
          Llogaritë
          <v-spacer />
          <f-action-btn icon="add" @click="createAccountsModal = true" />
        </v-card-title>
        <v-card-subtitle class="pt-0">
          <v-text-field
            class="search-bar"
            v-model="filter"
            prepend-inner-icon="search"
            label="Kërko"
            single-line
            hide-details
            clearable
          />
        </v-card-subtitle>
        <div class="balance-column">
          Balanca
        </div>

        <liquor-tree
          v-if="loaded"
          :data="treeData"
          :filter="filter"
          :options="treeOptions"
          @node:selected="onNodeSelected"
        >
          <div slot-scope="{ node }" class="node-container">
            <div @click="changeNodeState(node)" class="node-text">
              {{ node.data.code }} - {{ node.data.name }}
            </div>
            <div class="node-controls">
              <f-action-btn icon="add" @click="showCreateModal(node)" />
              <f-action-btn icon="edit" @click="showEditModal(node)" />
              <f-action-btn icon="delete" @click="removeNode(node)" />
            </div>
            <div class="balance-value">
              {{ node.data.balance }}
            </div>
          </div>
        </liquor-tree>
      </v-card>
      <v-dialog
        width="50%"
        height="auto"
        v-model="createAccountsModal"
        name="create_account"
      >
        <v-card>
          <create-account @close="closeModal(), fetchData()" />
        </v-card>
      </v-dialog>
      <v-dialog
        width="50%"
        height="auto"
        v-model="createSubAccountsModal"
        name="create_location"
      >
        <create-account
          @close="closeModal(), fetchData()"
          v-if="createSubAccountsModal"
          :key="treeNode.id || 0"
          :account-id="treeNode ? treeNode.id : null"
        />
      </v-dialog>
      <v-dialog
        width="50%"
        height="auto"
        v-model="editAccountsModal"
        name="edit_account"
      >
        <edit-account
          v-if="treeNode"
          :key="treeNode.id || 0"
          @close="closeModal"
          @updated="fetchData()"
          :account-id="treeNode ? treeNode.id : null"
          :data="treeNode.data"
        />
      </v-dialog>
      <v-dialog
        width="30%"
        height="auto"
        v-model="deleteAccountsModal"
        name="delete_account"
      >
        <v-card>
          <v-card-title class="light">
            A jeni te sigurte per fshirjen e llogarise :
            {{
              selectedSubAccountsToDelete
                ? selectedSubAccountsToDelete.data.text
                : ''
            }}
          </v-card-title>
          <v-card-actions>
            <v-spacer />
            <v-btn text color="gray" @click="closeModal">Anullo</v-btn>
            <f-submit-btn
              label="Fshi"
              :disabled="loading"
              @click="deleteAccounts(selectedSubAccountsToDelete)"
            />
          </v-card-actions>
        </v-card>
      </v-dialog>
      <toast
        @toast-updated="showNotification"
        :type="type"
        :message="message"
        :snackbar="showNotification"
      >
        {{ message }}
      </toast>
    </v-col>
  </v-row>
</template>

<script lang="ts">
import LiquorTree from 'liquor-tree'
import api from '../../../plugins/api'
import { Vue, Component } from 'vue-property-decorator'
import FActionBtn from '@/components/buttons/FActionBtn.vue'
import FSubmitBtn from '@/components/buttons/FSubmitBtn.vue'
import CreateAccount from '@/views/Accounts/components/CreateAccount.vue'
import EditAccount from '@/views/Accounts/components/EditAccount.vue'
import Toast from '@/components/toasts/Toast.vue'

@Component({
  components: {
    EditAccount,
    CreateAccount,
    FSubmitBtn,
    FActionBtn,
    LiquorTree,
    Toast,
  },
})
export default class AccountsTree extends Vue {
  loaded?: boolean = false
  filter?: any = ''
  treeNode: object = {}
  treeData: Array<object> = []

  createAccountsModal = false
  editAccountsModal = false
  createSubAccountsModal = false
  selectedSubAccountsToDelete?: any = ''
  deleteAccountsModal = false
  loading = false
  treeOptions: object = {
    filter: {
      emptyText: 'Nuk u gjet asnjë rezultat',
      matcher: (query: string, node: any) => {
        const filter: any = query.toLowerCase()
        let name = false
        if (node.data.name) {
          name = node.data.name.toLowerCase().match(filter)
        }
        let code = false
        if (node.data.code) {
          code = node.data.code.toLowerCase().match(filter)
        }
        return name || code
      },
      plainList: true,
      showChildren: false,
    },
  }
  message = ''
  showNotification = false
  type = ''
  showCreateModal() {
    this.createSubAccountsModal = true
  }

  showEditModal(node: object) {
    this.editAccountsModal = true
    this.treeNode = node
  }

  removeNode(node: object) {
    this.deleteAccountsModal = true
    this.selectedSubAccountsToDelete = node
  }

  closeModal() {
    this.createAccountsModal = false
    this.createSubAccountsModal = false
    this.editAccountsModal = false
    this.deleteAccountsModal = false
  }

  onNodeSelected(node: any) {
    this.treeNode = node
    this.$root.$emit('account-selected', node.id)
  }

  changeNodeState(node: any) {
    if (node.selected()) {
      setTimeout(() => {
        node.unselect()
        this.$root.$emit('account-selected', null)
      }, 250)
    }
  }
  fetchData() {
    this.loaded = false
    api()
      .get('/api/account-management/accounts')
      .then(response => {
        this.treeData = response.data.data
        this.loaded = true
        this.treeNode = {}
      })
      .catch(() => {
        this.loaded = true
      })
  }
  deleteAccounts(node: any) {
    this.loading = true
    this.showNotification = false
    api()
      .delete(`/api/account-management/accounts/${node.id}`)
      .then(response => {
        this.showNotification = true
        this.message = response.data.message
        if (response.data.status === 0) {
          this.type = 'success'
        } else {
          this.type = 'error'
        }
        this.fetchData()
        this.closeModal()
      })
      .catch(error => {
        this.showNotification = true
        this.message = error.message
        this.type = 'error'
      })
      .finally(() => {
        this.loading = false
      })
  }
  mounted() {
    this.fetchData()
  }
}
</script>

<style scoped>
.tree {
  position: relative;
  top: 40px;
}
.node-container {
  display: flex;
  width: 100%;
}

.node-container:hover > .node-controls {
  display: block;
  float: right;
  position: absolute;
  top: 3px;
  right: 0;
  z-index: 1;
}

.tree-node.selected > .tree-content .node-container:hover > .node-controls {
  background: #e7eef7;
}

.node-controls {
  padding-left: 10px;
  display: none;
  background: #f6f8fb;
}

.node-text {
  padding: 5px;
  text-align: left;
  margin-right: 5px;
  flex: 1;
  width: 200px;
  white-space: nowrap;
  overflow: hidden;
  text-overflow: ellipsis;
}
.balance-column {
  display: flex;
  justify-content: flex-end;
  align-items: center;
  font-size: 18px;
  font-weight: 600;
  padding-right: 10px;
}
.balance-value {
  display: flex;
  justify-content: center;
  align-items: center;
}
</style>
